{$A8,B-,H+,I+,J-,K-,L+,M-,N+,P+,Q-,R-,T-,U-,V+,W-,X+,Y+,Z1}

//////////////////////////////////////////////////////////////////////
// NkStringList jbg
//
// NkStringListDelphi2009Ŏgp邽߂ɉ́B
//   Coded by T. Ichimaru
//   ver 0.00 2009/04/11
//
//@OriginalƓlɁA{\tgEFA̎gpAzzς
//@؂݂̐܂Bppo܂Ap
//  ۂĒ쌠\svłBRɂgB
//  ȂA̎gpɂĐs̐ӔC͈ؕ
//  ܂B\߂B

//////////
// NkStringList jbg
//
// TNkmemIniFile: ̕⏕NX TNkStringList 񋟂郆jbgłB
//@ Coded By T. Nakamura
//   Ver 0.3 2006/07/16
//
//  {\tgEFA̎gpAzzςɈ؂̐
//  ݂܂Bppo܂ApɍۂĒ쌠
//  \svłBRɂgB
//  ȂA̎gpɂĐs̐ӔC͈ؕ
//  ܂B\߂B

unit NkStringList;

interface
  uses windows,Classes, ContNrs, SysUtils;

type
  TNkHashedStringList = class;

  // TNkHashedStringList ̕ێNX
  TNkStringItem = class
  private
    // eNX(CaseSensitive ߂̂Ɏg)
    FOwner: TNkHashedStringList;
    // IuWFNgێ
    FObject: TObject;

    // IuWFNgݒ肷B
    procedure SetObject(const Value: TObject);
  public
    // 
    Str: string;
    // O
    Name: string;

    // RXgN^
    constructor Create(Owner: TNkHashedStringList; AStr, AName: string; o: TObject);
    // fXgN^
    destructor Destroy; override;

    // IuWFNgQ/ݒ肷vpeB
    // ̃vpeBIuWFNg̎jSB
    property Obj: TObject read FObject write SetObject;
  end;

  // TNkHashedStringList̕pnbV
  TNkStringHash = class(TCustomBucketList)
  private
    // 召̋
    FCaseSensitive: Boolean;
  protected
    // L[ɂoPc̑I@
    function BucketFor(AItem: Pointer): Integer; override;
    // L[ɂ錟Bʂ̓oPcƃCfbNXB
    function FindItem(AItem: Pointer; out ABucket: Integer;
      out AIndex: Integer): Boolean; override;
  public
    // RXgN^
    constructor Create;
    // fXgN^
    property CaseSensitive: Boolean read FCaseSensitive
                                    write FCaseSensitive;
  end;

  // L[dO
  ENkSTringListDuplicateException = class(Exception)
  end;

  // nbV TStrings(ۃNX)
  // ̕񃊃Xǵ@O⓯2}łȂƂɒӁB
  // ̃NX TNkMemIniFilepɍ܂B
  // ڂhLg͍Ă܂B
  // ɗpꂽ͓e悭ᖡĂgĂB
  TNkHashedStringList = class(TStrings)
  private
    // L[nbV
    FKeyHash: TNkStringHash;
    // 񃊃Xg
    FList: TObjectList;
    // IuWFNg폜tO
    FHasObjects: Boolean;
    // Oŕ̑召ʂ邩B
    FCaseSensitive: Boolean;
    FUseNameAsKey: Boolean;

    // nbVValue
    // O݂Ȃꍇ '' ԂB
    function GetValuesByName(Name: string): string;
    // nbVōValueZbg
    // O݂ĂȂꍇ͐Vɕ񂪍B
    procedure SetValuesByName(Name: string; const Value: string);
    // nbV Object 
    // O݂Ȃꍇ Nil ԂB
    function GetObjectsByName(Name: string): TObject;
    // nbVōObjectZbg
    procedure SetObjectsByName(Name: string; const Value: TObject);
    // Oŕ̑召ʂ邩ݒ肷B
    procedure SetCaseSensitive(const Value: Boolean);
    // nbV̍č\z
    procedure RebuildHash;
    // ŃIuWFNg
    function GetObjectsByString(Str: string): TObject;
    // ŌăIuWFNgݒ
    // O݂ĂȂꍇ͉ȂB
    procedure SetObjectsByString(Str: string; const Value: TObject);
    // nbṼL[ƂĖOg
    procedure SetUseNameAsKey(const Value: Boolean);
  protected
    // IndexԖڂ̕擾
    function Get(Index: Integer): String; override;
    // IndexԖڂ̃IuWFNg擾
    function GetObject(Index: Integer): TObject; override;
    // IndexԖڂ̃IuWFNgݒ
    procedure PutObject(Index: Integer; AObject: TObject); override;
    // IndexԖڂ̕ݒ
    procedure Put(Index: Integer; const S: String); override;
    // s擾
    function GetCount: Integer; override;
  public
    // IndexԖڂɕ}
    procedure Insert(Index: Integer; const S: string); override;
    // RXgN^
    constructor Create(
      HasObjects: Boolean = True  // IuWFNgj
    );
    // fXgN^
    destructor Destroy; override;
    // 񃊃XgNA
    procedure Clear; override;
    // IndexԖڂ̕폜
    procedure Delete(Index: Integer); override;
    // IuWFNg̎j
    property HasObjects: Boolean read FHasObjects write FHasObjects;
    // CurIndexԖڂ̕ NewIndexԖڂɈړ
    procedure Move(CurIndex: Integer; NewIndex: Integer); override;
    // ŌăCfbNX𓾂
    // x̂ŒӁBɂ ValuesByStr  ObjectsByStr vpeB
    // 
    function IndexOf(const S: string): Integer; override;
    // OŌăCfbNX𓾂
    // x̂ŒӁBɂ ValuesByName  ObjectsByName vpeB
    // 
    function IndexOfName(const Name: String): Integer; override;
    // O񃊃Xgɑ݂邩ԂB
    function NameExists(Name: string): Boolean;
    // O񃊃Xgɑ݂邩ԂB
    function StrExists(Str: string): Boolean;
    // OŒl擾/ݒ肷vpeBBłB
    property ValuesByName[Name: string]: string
             read GetValuesByName write SetValuesByName;
    // OŃIuWFNg擾/ݒ肷vpeBBłB
    property ObjectsByName[Name: string]: TObject
             read GetObjectsByName write SetObjectsByName;
    // ŃIuWFNg擾/ݒ肷vpeBBłB
    property ObjectsByString[Str: string]: TObject
             read GetObjectsByString write SetObjectsByString;
    // Oő啶/ʂ邩tO
    property CaseSensitive: Boolean read FCaseSensitive write SetCaseSensitive;
    // ÕnbV邩ÃnbV邩߂vpeB
    // ύXƕ񂪑SĔj邱ƂɒӁI
    property UseNameAsKey: Boolean read FUseNameAsKey write SetUseNameAsKey;
  end;

implementation

// nbṼoPc
const NumBucketsForTNkStringHash = 1024;

{ TNkHashedStringList }

// Xg̃NA
procedure TNkHashedStringList.Clear;
begin
  // nbVNA
  FKeyHash.Clear;
  // XgNA
  // TObjectList TNkStringItem폜B
  // TNkStringItem  HasObjects  True ȂIuWFNg폜B
  FList.Clear;
end;

// RXgN^
constructor TNkHashedStringList.Create(
  HasObjects: Boolean = True);// IuWFNg폜B
begin
  // nbV
  FKeyHash := TNkStringHash.Create;
  // 񃊃Xg
  FList := TObjectList.Create;

  // IvVtOftHgݒ肷B
  // 폜=BOő啶͋ʂȂB
  FHasObjects := HasObjects;
  FCaseSensitive := False;
  FUseNameAsKey := False;
  FKeyHash.CaseSensitive := FCaseSensitive;
end;

// ̍폜
procedure TNkHashedStringList.Delete(Index: Integer);
var
  Item: TNkStringItem;
begin
  inherited;
  // CfbNX當߂B
  Item := FList[Index] as TNkStringItem;

  if FUseNameAsKey then
  begin
    // nbVOB
    if Item.Name <> '' then
      FKeyHash.Remove(@Item.Name);
  end;
  FKeyHash.Remove(@Item.Str);

  // Xg폜
  // (TNkStringItem ƃIuWFNg̎js)
  FList.Delete(Index);
end;

// fXgN^
destructor TNkHashedStringList.Destroy;
begin
  // 񃊃Xgj
  FList.Free;
  // nbVj
  FKeyHash.Free;

  inherited;
end;

// w肳ꂽuOv̕񂪑݂Ă邩ԂB
// ̎擾
function TNkHashedStringList.Get(Index: Integer): String;
begin
  Result := (FList[Index] as TNkSTringItem).Str;
end;

// 񐔂̎擾
function TNkHashedStringList.GetCount: Integer;
begin
  Result := FList.Count;
end;

// IuWFNg̎擾
function TNkHashedStringList.GetObject(Index: Integer): TObject;
var
  Item: TNkStringItem;
begin
  Item := FList[Index] as TNkSTringItem;
  Result := Item.Obj;
end;

// IuWFNg𖼑OŎ擾
function TNkHashedStringList.GetObjectsByName(Name: string): TObject;
var
  Data: Pointer;
  Index: Integer;
begin
  Result := Nil;

  if FUseNameAsKey then
  begin
    if FKeyHash.Find(@Name, Data) then
      Result := TNkStringItem(Data).Obj;
  end
  else
  begin
    Index := IndexOfName(Name);
    if Index >= 0 then
      Result := (FList[Index] as TNkStringItem).FObject;
  end;
end;

// IuWFNg𖼑OŎ擾
function TNkHashedStringList.GetObjectsByString(Str: string): TObject;
var
  Data: Pointer;
  Index: Integer;
begin
  Result := Nil;
  if not FUseNameAsKey then
  begin
    if FKeyHash.Find(@Str, Data) then
      Result := TNkStringItem(Data).Obj;
  end
  else
  begin
    Index := IndexOf(Str);
    if Index >= 0 then
      Result := (FList[Index] as TNkStringItem).FObject;
  end;
end;

// l𖼑OŎ擾
// O݂Ȃꍇ '' ԂB
function TNkHashedStringList.GetValuesByName(Name: string): string;
var
  Data: Pointer;
  Index: Integer;
begin
  Result := '';

  if FUseNameAsKey then
  begin
    if FKeyHash.Find(@Name, Data) then
    begin
      Result := Copy(TNkStringItem(Data).Str, Length(Name) + 2, MaxInt);
    end;
  end
  else
  begin
    Index := IndexOfName(Name);
    Result := Copy((FList[Index] as TNkStringItem).Str, Length(Name) + 2, MaxInt);
  end;
end;

// CfbNX𕶎Ŏ擾(jAT[`Ȃ̂Œᑬ)
function TNkHashedStringList.IndexOf(const S: string): Integer;
var
  Data: Pointer;
  i: Integer;
  Item: TNkStringItem;
begin
  Result := -1;

  if not FUseNameAskey then
  begin
  if FkeyHash.Find(@S, Data) then
    Result := FList.IndexOf(TObject(Data));
  end
  else
  begin
    for i := 0 to Count-1 do
    begin
      Item := FList[i] as TNkStringItem;
      if FCaseSensitive then
      begin
        if AnsiCompareStr(Get(Result), Item.Str) = 0 then
        begin
          Result := i;
          Exit;
        end;
      end
      else
      begin
        if AnsiCompareText(Get(Result), Item.Str) = 0 then
        begin
          Result := i;
          Exit;
        end;
      end;
    end;
   Result := -1;
  end;
end;

function TNkHashedStringList.IndexOfName(const Name: String): Integer;
var
  Data: Pointer;
  i: Integer;
  Item: TNkStringItem;
begin
  Result := -1;

  if FUseNameAskey then
  begin
  if FkeyHash.Find(@Name, Data) then
    Result := FList.IndexOf(TObject(Data));
  end
  else
  begin
    for i := 0 to Count-1 do
    begin
      Item := FList[i] as TNkStringItem;
      if FCaseSensitive then
      begin
        if AnsiCompareStr(Get(Result), Item.Name) = 0 then
        begin
          Result := i;
          Exit;
        end;
      end
      else
      begin
        if AnsiCompareText(Get(Result), Item.Name) = 0 then
        begin
          Result := i;
          Exit;
        end;
      end;
    end;
   Result := -1;
  end;
end;

// IndexԖڂɑ}
procedure TNkHashedStringList.Insert(Index: Integer; const S: string);
var
  Item: TNkStringItem;
  Name: string;
begin
  Name := ExtractName(s);
  Item := TNkStringItem.Create(Self, S, Name, Nil);
  if FUseNameAsKey then
  begin
    if Name <> '' then
      FkeyHash.Add(@Item.Name, Item);
  end
  else
    FKeyHash.Add(@Item.Str, Item);
  FList.Insert(Index, Item);
end;

// ̈ړ
procedure TNkHashedStringList.Move(CurIndex, NewIndex: Integer);
var
  TempString: string;
  TempObject: TObject;
  Item: TNkStringItem;
begin
  if CurIndex <> NewIndex then
  begin
    BeginUpdate;
    try
      Item := FList[CurIndex] as TNkStringItem;
      TempString := Item.Str;
      TempObject := Item.Obj;
      Item.Obj := Nil;
      Delete(CurIndex);
      InsertObject(NewIndex, TempString, TempObject);
    finally
      EndUpdate;
    end;
  end;
end;

// ̐ݒ
function TNkHashedStringList.NameExists(Name: string): Boolean;
begin
  if FUseNameAsKey then
    Result := FKeyHash.Exists(@Name)
  else
    Result := IndexOfname(Name) >= 0;
end;

procedure TNkHashedStringList.Put(Index: Integer; const S: String);
var
  Item: TNkSTringItem;
begin
  inherited;
  Item := FList[Index] as TNkStringItem;
  if FUseNameAsKey then
  begin
    if Item.Name <> '' then
      FKeyHash.Remove(@Item.Name);
  end
  else
    FKeyHash.Remove(@Item.Str);
  Item.Str := S;
  Item.Name := ExtractName(S);
  if FUseNameAsKey then
  begin
    if Item.Name <> '' then
      FKeyHash.Add(@Item.Name, Item);
  end
  else
    FkeyHash.Add(@Item.Str, Item);
end;

// IuWFNg̐ݒ
procedure TNkHashedStringList.PutObject(Index: Integer; AObject: TObject);
var
  Item: TNkStringItem;
begin
  Item := Flist[Index] as TNkStringItem;
  Item.Obj := AObject;
end;

// nbVč\z
procedure TNkHashedStringList.RebuildHash;
var
  i: Integer;
  Item: TNkStringItem;
begin
  FKeyHash.Clear;
  FKeyHash.CaseSensitive := CaseSensitive;
  for i := 0 to Count-1 do
  begin
    Item := Flist[i] as TNkStringItem;
    if FUseNameAskey then
    begin
      if Item.Name <> '' then
        FKeyHash.Add(@Item.Name, Item);
    end
    else
      FKeyHash.Add(@Item.Str, Item);
  end;
end;

// 召ʂ̐ݒ
procedure TNkHashedStringList.SetCaseSensitive(const Value: Boolean);
begin
  if FcaseSensitive <> Value then
  begin
    FCaseSensitive := Value;
    Clear;
    FKeyHash.CaseSensitive := FCaseSensitive;
  end;
end;

// IuWFNg𖼑OŌĐݒ
procedure TNkHashedStringList.SetObjectsByName(Name: string; const Value: TObject);
var
  Data: Pointer;
  Index: Integer;
begin
  if FUseNameAskey then
  begin
    if FKeyHash.Find(@Name, Data) then
      TNkStringItem(Data).Obj := Value;
  end
  else
  begin
    Index := IndexOfName(Name);
    if Index >= 0 then
      (FList[Index] as TNkStringItem).Obj := Value;
  end;
end;

// l𖼑OŌĐݒ
// O݂ĂȂꍇ͉ȂB
procedure TNkHashedStringList.SetObjectsByString(Str: string;
  const Value: TObject);
var
  Data: Pointer;
  Index: Integer;
begin
  if not FUseNameAsKey then
  begin
  if FKeyHash.Find(@Str, Data) then
    TNkStringItem(Data).Obj := Value;
  end
  else
  begin
    Index := IndexOf(Str);
    if Index >= 0 then
      (FList[Index] as TNkStringItem).Obj := Value;
  end;
end;

// nbVōValueZbg
// O݂ĂȂꍇ͐Vɕ񂪍B
procedure TNkHashedStringList.SetUseNameAsKey(const Value: Boolean);
begin
  if FUseNameAsKey <> Value then
  begin
    FUseNameAsKey := Value;
    RebuildHash;
  end;
end;

procedure TNkHashedStringList.SetValuesByName(Name: string; const Value: string);
var
  Data: Pointer;
  Index: Integer;
  v: string;
begin
  if (Length(Value) > 0) and
     ((AnsiPos(' ', Value) > 0) or (AnsiPos('"', Value) > 0)) then
    v := AnsiQuotedStr(Value, '"')
  else
    v := Value;
  if FUseNameAsKey then
  begin
    if FKeyHash.Find(@Name, Data) then
    begin
      TNkStringItem(Data).Str :=
        Trim(Name) + '=' + v;
    end
    else
      Append(Trim(Name) + '=' + v);
  end
  else
  begin
    Index := IndexOfName(Name);
    if Index >= 0 then
      (FList[Index] as TNkStringItem).Str :=
        Trim(Name) + '=' + v
    else
      Append(Trim(Name) + '=' + v);
  end;
end;

function TNkHashedStringList.StrExists(Str: string): Boolean;
begin
  if not FUseNameAsKey then
    Result := FkeyHash.Exists(@Str)
  else
    result := IndexOf(Str) >= 0;
end;



{ TNkStringItem }

// RXgN^
constructor TNkStringItem.Create(Owner: TNkHashedStringList;
                                 AStr, AName: string;
                                 o: TObject);
begin
  FOwner := Owner;
  Str := AStr;
  Name := AName;
  FObject := o;
end;

// fXgN^
destructor TNkStringItem.Destroy;
begin
  Obj := Nil;
  inherited;
end;

// IuWFNg̐ݒ
procedure TNkStringItem.SetObject(const Value: TObject);
begin
  if FOwner.HasObjects then
    FObject.Free;
  FObject := Value;
end;

{ TNkStringHash }

// ŃoPcI
function TNkStringHash.BucketFor(AItem: Pointer): Integer;
var
  s: string;
  i: Integer;
begin
  s := PString(AItem)^;

  if Not CaseSensitive then
    s := UpperCase(s);

  Result := 0;

  for i := 1 to Length(s) do
    Result := ((Result + Ord(s[i])) * 9973) mod NumBucketsForTNkStringHash;
end;

// RXgN^
constructor TNkStringHash.Create;
begin
  BucketCount := NumBucketsForTNkStringHash; // oPcݒ
end;

// Ō
function TNkStringHash.FindItem(AItem: Pointer; out ABucket,
  AIndex: Integer): Boolean;
var
  I: Integer;
begin
  Result := False;
  ABucket := BucketFor(AItem);
  with Buckets[ABucket] do
    for I := 0 to Count - 1 do
      if CaseSensitive then
      begin
        if PString(Items[I].Item)^ = PString(AItem)^ then
        begin
          AIndex := I;
          Result := True;
          Break;
        end;
      end
      else
      begin
        if CompareText(PString(Items[I].Item)^, PString(AItem)^) = 0 then
        begin
          AIndex := I;
          Result := True;
          Break;
        end;
      end;
end;

end.
